jQuery(document).ready(function() {
    if (jQuery('.cms2cms-drupal-wrapper').length > 0) {

        ;(function (document, global, $, undefined) {

            var cmsOverlay = $('#cms_overlay');
            var stepHide = $('.step.active').siblings('div > form').slideUp();

            cms2cms = {
                authentication: '',

                // callbacks
                callback_auth: function (data) {
                    $('.cms2cms-drupal-error').hide();
                    for (var error in  data.errors) {
                        var message = (data.errors[error]) ? data.errors[error] : 'Invalid data';
                        $('.cms2cms-drupal-error.' + error + ' span').html(message).parent().fadeIn();
                    }
                    if (!data.errors && data.redirect && data.accessKey) {
                        // save key
                        var action_data = {
                            action: 'cms2cms_drupal_save_options',
                            accessKey: data.accessKey,
                            login: data.email
                        };
                        $.post(ajaxurl, action_data, function (data) {
                            eval('data = ' + data);
                            if (!data.errors) {
                                // reload page to change form and show logout link
                                window.location.href = window.location.pathname + window.location.search;
                            }
                            else {

                                cms2cms.show_error(data.errors);
                                cms2cms.form_loading_hide($('#cms2cms_drupal_form_register'));
                            }
                        });
                    } else {
                        if (data.errors) {
                            cms2cms.show_error(data.errors);
                            cms2cms.form_loading_hide($('#cms2cms_drupal_form_register'));
                            $('.step-sign').next('div').find('form').slideDown();
                        }
                    }
                },

                callback_verify: function (data) {
                    if (data.errors) {
                        cms2cms.show_error(data.errors);
                        cms2cms.form_loading_hide($('#cms2cms_drupal_form_verify'));
                    }
                    else {
                        cms2cms.hide_error();
                        if (data.hasOwnProperty('migration') && data.migration != '') {
                            var step_run = $('.cms2cms_drupal_step_migration_run');

                            if (data.hasOwnProperty('targetUrl')) {
                                step_run.find('input[name="targetUrl"]').val(data.targetUrl);
                            }
                            if (data.hasOwnProperty('targetType')) {
                                step_run.find('input[name="targetType"]').val(data.targetType);
                            }
                            if (data.hasOwnProperty('sourceUrl')) {
                                step_run.find('input[name="sourceUrl"]').val(data.sourceUrl);
                            }
                            if (data.hasOwnProperty('sourceType')) {
                                step_run.find('input[name="sourceType"]').val(data.sourceType);
                            }
                            if (data.hasOwnProperty('migration')) {
                                step_run.find('input[name="migrationHash"]').val(data.migration);
                                $('#migrationHash').val(data.migration);
                            }
                            cms2cms.move(step_run);
                        }
                        else {
                            cms2cms.show_error(localization_drupal_cms['Unknown error, please contact us http://www.cms2cms.com/contacts/']);
                        }
                    }
                },

                // validators
                auth_check_password: function (form, callback) {
                    var email = form.find('input[name="email"]').val();
                    if (email == null || email == 1 || email == '') {
                        email = 'user_mail@mail.com';
                    }

                    data = form.serialize();

                    cms2cms.form_loading_show(form);
                    cms2cms.get_data(form.attr('action'), data, callback);
                },
                verify: function (form, callback) {
                    cms2cms.form_loading_show(form);
                    cms2cms.get_auth('', function () {
                        cms2cms.get_data(form.attr('action'), form.serialize(), callback);
                    });
                },

                // move to step form
                move: function (form) {
                    $('#cms2cms_drupal_accordeon').find('form.step_form').each(function () {
                        cms2cms.form_loading_hide($(this), true);
                        $(this).slideUp();
                    });
                    form.slideDown();
                },

                // show error
                show_error: function (error) {
                    var form = $('#cms2cms_drupal_accordeon').find('.cms2cms_drupal_accordeon_item:visible').find('form');
                    var errorText = '';
                    if (typeof(error) == 'object') {
                        for (errorItem in error) {
                            errorText += errorItem + " : " + error[errorItem] + "<br/>";
                        }
                    }
                    else {
                        errorText += error;
                    }
                },

                hide_error: function () {
                    var form = $('#cms2cms_drupal_accordeon').find('.cms2cms_drupal_accordeon_item:visible').find('form');
                    form.find('.cms2cms-drupal-error span').html('').parent().fadeOut();
                },

                // get auth data
                get_auth: function (serialized, callback) {
                    var action_data = {
                        action: 'cms2cms_drupal_get_options',
                        serialized: serialized
                    };
                    $.post(ajaxurl, action_data, function (data) {
                        eval('data = ' + data);
                        if (!data.errors) {
                            if (data.accessKey == '') {
                                cms2cms.authentication = '';
                            }
                            else {
                                data = JSON.stringify(data);
                                cms2cms.authentication = encodeURIComponent(data);
                                if (typeof(callback) == 'function') {
                                    callback();
                                }
                            }
                        }
                        else {
                            cms2cms.show_error(data.errors);
                        }
                    });
                },

                // save auth data
                save_auth: function (login, key) {
                    var action_data = {
                        action: 'cms2cms_drupal_save_options',
                        cms2cms_drupal_login: login,
                        cms2cms_drupal_key: key
                    };

                    $.post(ajaxurl, action_data, function (data) {
                    });
                },

                // get data via JSONP
                get_data: function (url, serialized, callback) {
                    var authentication = '';
                    if (cms2cms.authentication != 0) {
                        authentication = "authentication=" + cms2cms.authentication;
                    }

                    global.JSONP(
                        url +
                        "?callback=cms2cms." + callback
                        + "&" + authentication
                        + "&" + serialized
                        , cms2cms[callback]
                    );
                },

                // loading animation
                form_loading_show: function (form, only_spinner) {
                    jQuery('#cms_overlay').fadeIn();
                    if (!only_spinner) {
                        form.slideDown();
                    }
                },

                form_loading_hide: function (form, only_spinner) {
                    jQuery('#cms_overlay').fadeOut();
                    if (!only_spinner) {
                        form.slideUp();
                    }
                },

                pushEvent: function (data) {
                    if (!cms2cms.getDisableEventCookie()) {
                        var form = $('.cms2cms_drupal_step_migration_run');
                        var sourceType = form.find('input[name="sourceType"]').val();
                        var targetType = form.find('input[name="targetType"]').val();

                        try {
                            mixpanel.track(data, {
                                type: data,
                                sourceType: sourceType,
                                targetType: targetType
                            });
                        }
                        catch (e) {
                        }
                        ;
                    }

                },

                setDisableEventCookie: function (value) {
                    var date = new Date();
                    date.setTime(date.getTime() + (1000 * 24 * 60 * 60 * 1000));
                    var expires = "; expires=" + date.toGMTString();

                    value = value || 0;

                    var domain = document.location.hostname;

                    document.cookie = "cms2cms_drupal_disable_events=" + value +
                        "; expires=" + expires +
                        "; path=" + "/" +
                        "; domain=" + domain;
                },

                getDisableEventCookie: function () {
                    var cookie = " " + document.cookie;
                    var search = " cms2cms_drupal_disable_events=";
                    var setStr = null;
                    var offset = 0;
                    var end = 0;
                    if (cookie.length > 0) {
                        offset = cookie.indexOf(search);
                        if (offset != -1) {
                            offset += search.length;
                            end = cookie.indexOf(";", offset);
                            if (end == -1) {
                                end = cookie.length;
                            }
                            setStr = unescape(cookie.substring(offset, end));
                        }
                    }
                    return (setStr);
                }
            };

            $(document).ready(function () {

                if (typeof(config) != 'undefined') {
                    var appUrl = config.host;
                } else {
                    var appUrl = 'http://app.cms2cms.com';
                }

                var interval = setInterval(function () {
                    var end = false;

                    key = $('#accessKey').val();
                    email = $('#email').val();
                    if (key && email) {
                        data = jQuery.ajax(
                            {
                                url: appUrl + '/wizard/plugin-migration-progress?' + jQuery('#cms2cms_drupal_form_estimate').serialize(),
                                dataType: 'jsonp',
                                success: function (data) {
                                    data = data.data;

                                    if (data && data.hasOwnProperty('migration')) {
                                        status = data.status;
                                        if (status == 'running') {
                                            var progress = data.progress;

                                            if (Array.isArray(progress)) {
                                                var previewHtml = '';

                                                var i = 0;
                                                var progressData = progress[i];
                                                var job = progressData.job;
                                                var percent = progressData.percent;

                                                setPersentToProgress(3);

                                                var percentAll = 0;
                                                for (; i < progress.length; i++) {
                                                    percentAll += progress[i].percent;
                                                }
                                                setPersentToProgress(Math.min(percentAll / progress.length, 3));


                                                $('#progress').html(previewHtml); //need if started migration not from plugin
                                                $('#currentMigration').val(data.migration);
                                            }
                                        }
                                        else if (status == 'complete') {

                                            $('#demo-complete').fadeIn();
                                            var previewContent = data.migratedPreviewContent;

                                            var previewHtml = '';
                                            var i = 0;
                                            for (; i < previewContent.length; i++) {
                                                var urlData = previewContent[i];
                                                previewHtml +=
                                                    "<a href='" + urlData.sourceUrl + "'>" + urlData.title + "</a> - " +
                                                    "<a href='" + urlData.targetUrl + "'>" + localization_drupal_cms['New version']+"</a><br>";
                                            }

                                            $('.migrated-pages').html(previewHtml);
                                            $('.migrated-pages').slideDown();
                                            jQuery(".check-migr-pages").show();
                                            jQuery("#start-migration").show();
                                            jQuery('#progress').fadeOut();
                                            jQuery('.m-progress').hide();
                                            jQuery(".price").show();
                                            jQuery('.meter').fadeOut();

                                            $('input[name="migrationHash"]').val($("[name='currentMigration']").val());

                                            setPersentToProgress(100);
                                            end = true;
                                            clearInterval(interval);
                                        }
                                        else {
                                            setPersentToProgress(3);
                                        }
                                    }
                                    else {

                                    }

                                }
                            }
                        );
                    }

                    if (end) {
                        clearInterval(interval);
                    }
                }, 10000);

                $("#verifySource_drupal").click(function (event, form) {
                    form = $('#cms2cms_drupal_form_estimate');
                    cms2cms.form_loading_show(form);
                    event.preventDefault();
                    data = jQuery.ajax(
                        {
                            url: appUrl + '/wizard/plugin-verify-source-bridge?' + jQuery('#cms2cms_drupal_form_estimate').serialize(),
                            dataType: 'jsonp',
                            success: function (data) {
                                if (!data.error) {

                                    $('.cms2cms-drupal-error span').parent().hide();
                                    $('#cms2cms_drupal_accordeon_item_id_1').hide();
                                    $('#optionsForm').show();
                                    $('.step.active').removeClass('active').addClass('done');
                                    $('.step.step-options').addClass('active').next('div').find('form').slideDown({
                                        delay: 1000
                                    });
                                    jQuery('#cms_overlay').fadeOut();
                                }
                                else {

                                    $('.cms2cms-drupal-error span').html(data.error).parent().fadeIn();
                                    jQuery('#cms_overlay').fadeOut();
                                    return;
                                }

                                if (data.source) {
                                    $('#sourceCmsInfo').html('Cms Type: ' + data.source.type + '. Cms version: ' + data.source.version);
                                }

                                $("[name='hash']").val(data.migration.hash);

                                var formData = "<input type='hidden' name='hash' value='" + data.migration.hash + "'/>";

                                if (data.options) {
                                    formData += '<h3>'+localization_drupal_cms['Mapping options:']+'</h3>';
                                    var counterForCheckbox = 0;
                                    for (var type in data.options) {

                                        formData += '<div class="mapping-space"><b>' + type + '</b></div>';

                                        for (var module in data.options[type]) {

                                            for (var srcModules in data.options[type][module]) {
                                                var src = data.options[type][module][srcModules];
                                                var trgt = module;
                                                formData += '<div class="checkbox"><input type="checkbox" checked="checked" id="mappingOption[' + trgt + '][' + counterForCheckbox + ']" name="mappingOption[' + trgt + '][' + counterForCheckbox + ']" value="' + src + '">';
                                                formData += '<label class="estim-icons options-checked" for="mappingOption[' + trgt + '][' + counterForCheckbox + ']">' + src.replace('cms2cms:', '') + '→' + trgt.replace('cms2cms:', '').replace(/\%+(.*?)\%/,' ($1)') + '</label></div>';
                                                counterForCheckbox++;

                                            }
                                        }

                                    }
                                }

                                if (data.additionalOptions) {
                                    formData += '<h3>'+localization_drupal_cms['Additional options:']+'</h3>';
                                    formData += '<input type="hidden" name="allAdditionalOptions" value="">';
                                    for (var name in data.additionalOptions) {
                                        if (data.additionalOptions[name][0] != undefined) {
                                            var title = data.additionalOptions[name][0].target.title;
                                            var type = data.additionalOptions[name][0].target.viewType;

                                            if (type == 'CHECKBOX') {
                                                formData += '<div class="checkbox"><input type="checkbox" checked="checked" data-option-name="' + name + '" id="additionalOption[' + name + '][]" name="additionalOption[' + name + '][]" value="1">';
                                                formData += '<label class="estim-icons options-checked" for="additionalOption[' + name + '][]">' + title + '</label></div>';
                                            }
                                        }
                                    }
                                }

                                $('#mappingOptions .additional-options').html(formData);
                            }
                        }
                    );
                });

                $("#saveOptions_drupal").click(function (event, form) {
                    form = $('#optionsForm');
                    var inputs = form.find('input[type="checkbox"]:checked');
                    var container = form.find('input[name="allAdditionalOptions"]');

                    var result = {};
                    inputs.each(function () {
                        var name = $(this).data('option-name') || '';
                        if (name) {
                            var variant = $(this).data('option-variant') || '';
                            var value = $(this).val() || '';

                            if (!result[name]) {
                                // set default value
                                result[name] = (variant) ? {isEnabled: true, data: {}} : {isEnabled: true, data: []};
                            }

                            if (variant) {
                                result[name]['data'][value] = {
                                    isEnabled: true,
                                    value: variant
                                }
                            }

                            else {
                                result[name]['data'].push({
                                    isEnabled: true,
                                    value: 1
                                });
                            }
                        }

                    });

                    var json = JSON.stringify(result);
                    container.val(json);

                    cms2cms.form_loading_show(form);
                    event.preventDefault();

                    data = jQuery.ajax(
                        {
                            url: appUrl + '/wizard/plugin-save-options?' + jQuery('#optionsForm').serialize(),
                            dataType: 'jsonp',
                            success: function (data) {

                                if (!data.error) {
                                    $('#cms2cms_drupal_accordeon_item_id_2').hide();
                                    jQuery('#cms_overlay').fadeOut();
                                    $('.step.active').removeClass('active').addClass('done');
                                    $('.step.step-start').addClass('active').next('div').find('form').slideDown({
                                        delay: 1000
                                    });

                                    if (!data.canMigratePasswords) {
                                        $("[name='migrate_passwords']").prop("checked", false);
                                        $('#migratePasswords').hide();
                                    }

                                    var estimated = '';
                                    for (var type in data.counts) {
                                        var few = '';
                                        if (type == 'Forum Topics' || type == 'Content Pages') {
                                            if (data.counts[type] < 10) {
                                                few = data.counts[type];
                                            } else {
                                                few = '10';
                                            }
                                        } else {
                                            few = 'few';
                                        }
                                        estimated += '<br>' + type + ': ' + few + ' of ' + data.counts[type];
                                    }
                                    $('#ec').html(estimated);
                                }
                            }
                        });

                });


                $("#startDemo_drupal").click(function (event, form) {

                    form = $('#start_demo');
                    $('.cms2cms-drupal-error span').parent().hide();
                    $(".check-migr-pages").hide();
                    $(".price").hide();
                    $("#start-migration").hide();
                    cms2cms.form_loading_show(form);
                    setPersentToProgress(3);
                    event.preventDefault();
                    data = jQuery.ajax(
                        {
                            url: appUrl + '/wizard/plugin-prepare-bridge-migration?' + jQuery('#start_demo').serialize(),
                            dataType: 'jsonp',
                            success: function (data) {
                                cms2cms.form_loading_hide(form);
                                if (data.hash) {
                                    $("#migration").val(data.hash);
                                    $("#full-migration-price").html(data.cost);
                                    $("#currentMigration").val(data.hash);

                                    //clear view
                                    $('.migrated-pages').html('');
                                }
                                else if (data.error) {
                                    form.slideDown();
                                    $('.cms2cms-drupal-error span').html(data.error).parent().fadeIn();
                                }
                                else {
                                    cms2cms.form_loading_hide(form);
                                    $(".cms2cms-drupal-error span").html(localization_drupal_cms['Something gone wrong, please try again later.']).parent().fadeIn();
                                }
                                if (!data.error) {
                                    $('.step.active').removeClass('active').addClass('done');
                                    $('.step.step-complete').addClass('active').next('div').find('form').slideDown({
                                        delay: 1000
                                    });
                                }
                            }
                        })
                })

                var cms2cmsWrapper = $('.wrap.cms2cms-drupal-wrapper');
                var cms2cmsBlock = $('#cms2cms_drupal_accordeon');

                // Change tabs Register and Login
                var signInTabs = cms2cmsBlock.find('a.nav-tab');
                signInTabs.on('click', function (e) {
                    if (!$(this).hasClass('cms2cms-drupal-real-link')) {
                        e.preventDefault();
                        var activeClass = 'nav-tab-active';
                        if (!$(this).hasClass(activeClass)) {
                            signInTabs.removeClass(activeClass);
                            $(this).addClass(activeClass);
                            $(this).closest('.cms2cms_drupal_accordeon_item').find('form').attr('action', $(this).attr('href'));
                        }
                    }
                });

                var loginReg = $('.login-reg');
                var formContent = $('.cms2cms_drupal_accordeon_item_register').find('.center-content');
                var getLoginUrl = $('#loginUrl').val();
                var getRegisterUrl = $('#registerUrl').val();
                loginReg.on('click', function () {

                    formContent.toggleClass('login-cms');
                    if ($('.login-cms').length) {

                        loginReg.parent('p.account-register').show();
                        loginReg.parent('p.account-login').hide();
                        $('.user-name-block').fadeOut();
                        formContent.parent('form').attr('action', getLoginUrl);
                        $('.cms2cms-drupal-real-link').fadeIn();

                    } else {

                        loginReg.parent('p.account-register').hide();
                        loginReg.parent('p.account-login').show();
                        $('.user-name-block').fadeIn();
                        formContent.parent('form').attr('action', getRegisterUrl);
                        $('.cms2cms-drupal-real-link').fadeOut();
                    }
                });

                $('#select-prov').on('change', function () {
                    if ($(this).find(':selected').val() == 'searchEngine') {
                        $('.pages-url').fadeOut();
                    } else {
                        $('.pages-url').fadeIn();
                    }
                });

                $('.qmark').on('hover', function () {
                    $(this).find('span.hint').toggleClass('show-hint');
                });

                $('.additional-options').find('label').on('click', function () {
                    if (!$(this).parent('.checkbox').hasClass('label-grey')) {
                        $(this).toggleClass('options-checked');
                        if ($(this).hasClass('options-checked') == true) {
                            $(this).siblings('input').attr("checked", true);
                        } else {
                            $(this).siblings('input').attr("checked", false);
                        }

                    }
                });

//Progress bar

                $('#create_migration').on('click', function () {
                    location.reload();
                });


                $('.check-migr-pages').on('click', function () {
                    $(this).toggleClass('show-pages');
                    if ($('.show-pages').length) {
                        $('.migrated-pages').slideDown();
                    } else {
                        $('.migrated-pages').slideUp();
                    }
                });
                // Assign forms to JSONP
                cms2cmsBlock.find('form').on('submit', function (e) {
                    var callback = $(this).attr('callback');
                    var validate = $(this).attr('validate');

                    $(this).find('.cms2cms-drupal-error span').html('').parent().fadeOut();

                    if (callback && typeof(cms2cms[callback]) == 'function') {
                        if (validate && typeof(cms2cms[validate]) == 'function') {
                            e.preventDefault();
                            cms2cms[validate]($(this), callback);
                        }
                    }
                });

                // Send the event
                cms2cmsWrapper.find('[data-log-this]').not('input,textarea,select').on('click', function (e) {
                    cms2cms.pushEvent($(this).data('log-this'));
                });

                cms2cmsWrapper.on('blur', 'input[data-log-this], textarea[data-log-this], select[data-log-this]', function (e) {
                    cms2cms.pushEvent($(this).data('log-this'));
                });

                // Disable events
                cms2cmsWrapper.find('.stop-events').on('click', function (e) {
                    e.preventDefault();
                    cms2cms.setDisableEventCookie(1);
                    $('#cms2cms-drupal-allowed-events').hide();
                    $('#cms2cms-drupal-disabled-events').show();
                });

                // Allow events
                cms2cmsWrapper.find('.allow-events').on('click', function (e) {
                    e.preventDefault();
                    cms2cms.setDisableEventCookie(0);
                    $('#cms2cms-drupal-allowed-events').show();
                    $('#cms2cms-drupal-disabled-events').hide();
                });

                // check if allowed events on load
                if (cms2cms.getDisableEventCookie()) {
                    $('#cms2cms-drupal-allowed-events').show();
                    $('#cms2cms-drupal-disabled-events').hide();
                }
                else {
                    $('#cms2cms-drupal-allowed-events').hide();
                    $('#cms2cms-drupal-disabled-events').show();
                }
            });

        })(document, window, jQuery);

        (function ($) {

            jQuery(window).ready(function () {

                var step1 = $('body').find('.cms2cms-drupal-plugin .step-sign'),
                    step2 = $('body').find('.cms2cms-drupal-plugin .step-connect');

                if ($('.cms2cms-drupal-container').hasClass('cms2cms_drupal_is_activated')) {
                    $(step1).removeClass('active').addClass('done');
                    $(step2).addClass('active');
                }

                var cmsLoader = $('.circle-an'),
                    cmsOverlay = $('#cms_overlay');

                cmsOverlay.prependTo('#wpwrap');

                jQuery.fn.center = function () {
                    this.css("position", "fixed");
                    this.css("top", Math.max(0, (($(window).height() - $(this).outerHeight()) / 2) +
                            $(window).scrollTop()) + "px");
                    this.css("left", Math.max(0, (($(window).width() - $(this).outerWidth()) / 2) + $('#adminmenu').width() / 2 +
                            $(window).scrollLeft()) + "px");
                    return this;
                };
                $(window).resize(function () {
                    $(cmsLoader).center();
                });
                $(cmsLoader).center();
            });
        })(jQuery);

        var setPersentToProgress = function (percentVal, append) {
            var progressElement = jQuery('.meter span');
            var currentProgress = 0;

            if (!!append) {
                var width = jQuery(progressElement).css('width');
                var parentWidth = jQuery(progressElement).offsetParent().css('width');

                currentProgress = 100 * width / parentWidth;
            }

            jQuery(progressElement).css('width', parseInt(percentVal + currentProgress) + '%');
        };
    }
});